import scientificnotation as sn


def main():

    print("-----------------------")
    print("| codedrome.com       |")
    print("| Scientific Notation |")
    print("-----------------------\n")

    # python_output()

    # module_demo()
    
    show_table()


def python_output():

    very_small = 0.000000000003782
    very_large = 33589900145728984.0

    print(f"{very_small:e}")
    print(f"{very_small:.15f}")

    print()

    print(f"{very_large:e}")
    print(f"{very_large:.0f}")


def module_demo():

    very_small = 0.000000000005782
    very_large = 33589900145728984

    print(f"{sn.num_to_sn_string(very_small)}")
    print(f"{sn.num_to_sn_string(-very_small)}")
    print(f"{sn.num_to_sn_string(very_large)}")
    print(f"{sn.num_to_sn_string(-very_large)}")
    print(f"{sn.num_to_sn_string(0)}")

    print()

    print(f"{sn.num_to_sn_string(very_large, True)}")
    print(f"{sn.num_to_sn_string(very_large, False)}")


def show_table():

    n = 3.794
    # n = -3.794
    dp = 27

    for x in range(-24, 24):

        c = n * 10**x

        scinot_string = sn.num_to_sn_string(c)

        print(f" {c:>32,.{dp}f}", end="")
        print(f"     {c:.3e}", end="")
        print(f"     {scinot_string:<14} ")

        if dp > 0:
            dp -= 1


if __name__ == "__main__":

    main()
